Description

MailHandler.safe_receive has a rescue clause that seems to be intended to catch all exceptions and log it.

  def self.safe_receive(*args)

    receive(*args)

  rescue Exception => e

    logger.error "MailHandler: an unexpected error occurred when receiving email: #{e.message}" if

 logger

    return false

  end

 However, the expression "logger.error" does not log any events because the variable logger is undefined. Although there is a method

definition for "logger" at source:tags/4.0.0/app/models/mail_handler.rb#L77, you cannot call the method from

MailHandler.safe_receive because MailHandler.safe_receive is a class method and MailHandler#logger is an instance method.

As a result, the expression logger.error in MailHandler#safe_receive never logs errors because the expression itself causes

NameError. To avoid this, logger should be replaced with Rails.logger. The attached patch fixes this issue.

Related issues:

Related to Redmine - Patch #11497: Dry up logging in MailHandler class Closed

Has duplicate Redmine - Defect #28874: MailHandler does not log exceptions ca... Closed

Associated revisions

Revision 18066 - 2019-04-20 06:11 - Go MAEDA

MailHandler.safe_receive does not output any error log (#30457).

Patch by Go MAEDA.

Revision 18067 - 2019-04-20 06:17 - Go MAEDA

Merged r18066 from trunk to 4.0-stable (#30457).

Revision 18068 - 2019-04-20 06:18 - Go MAEDA

Merged r18066 from trunk to 3.4-stable (#30457).

Revision 18069 - 2019-04-20 06:56 - Go MAEDA

Use safe navigation operator (#30457).

History

#1 - 2019-01-22 07:27 - Go MAEDA

- Target version set to 4.1.0

Setting the target version to 4.1.0.

#2 - 2019-02-09 17:05 - Go MAEDA

- Has duplicate Defect #28874: MailHandler does not log exceptions caught added

#3 - 2019-02-10 02:05 - Go MAEDA
https://www.redmine.org/projects/redmine/repository/svn/entry/tags/4.0.0/app/models/mail_handler.rb#L77


- Related to Patch #11497: Dry up logging in MailHandler class added

#4 - 2019-04-20 06:15 - Go MAEDA

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Target version changed from 4.1.0 to 3.4.11

- Resolution set to Fixed

Committed the fix.

#5 - 2019-04-20 06:18 - Go MAEDA

- Status changed from Resolved to Closed

Files

fix-safe_receive-logging-error.diff 6.27 KB 2019-01-17 Go MAEDA
